## armci-mpi 0.4

=== profiler/Makefile ===
# just a hack - change this appropriately
ARMCI_INSTALL_PREFIX=../.lib

CPPFLAGS = -I../src
LIBS = -L$(ARMCI_INSTALL_PREFIX) -larmci

CC = mpicc
CFLAGS = -g $(CPPFLAGS)
SOFLAGS =  -shared -fPIC

LD = ld
LDFLAGS = -shared

all: libarmciprof.so profiling.o

libarmciprof.so: profiling.c
	$(CC) $(CFLAGS) $(SOFLAGS) $< $(LIBS) -o $@

#libarmciprof.so: profiling.o
#	$(LD) $(LDFLAGS) $< -o $@

profiling.o: profiling.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	-rm -f *.o *.so

## armci-mpi 0.0~git20160222

=== debian/changelog ===
armci-mpi (0.0~git20160222-2build1) bionic; urgency=medium

  * No-change rebuild for PIE compatibility.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 01 Feb 2018 23:22:06 -0800

armci-mpi (0.0~git20160222-2) unstable; urgency=medium

  * Team upload
  * Set ARMCI_USE_WIN_ALLOCATE=1 to fix test failures on 32-bit buildds
    (Closes: #816305)
  * Improve libarmci-mpi-dev package description (Closes: #857140)

 -- Graham Inggs <ginggs@debian.org>  Sun, 12 Mar 2017 22:03:20 +0200

armci-mpi (0.0~git20160222-1) unstable; urgency=medium

  * Initial upload (Closes: #815837).

 -- Michael Banck <mbanck@debian.org>  Mon, 29 Feb 2016 00:25:29 +0100

=== debian/control ===
Source: armci-mpi
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               mpi-default-bin,
               mpi-default-dev
Standards-Version: 3.9.6
Homepage: https://wiki.mpich.org/armci-mpi/index.php/Main_Page

Package: libarmci-mpi-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ARMCI-MPI (Development version)
 ARMCI-MPI is a completely rewritten implementation of the ARMCI one-sided
 communication interface that uses MPI RMA for one-sided communication.
 .
 The purpose of the Aggregate Remote Memory Copy (ARMCI) library is to provide
 a general-purpose, efficient, and widely portable remote memory access (RMA)
 operations (one-sided communication) optimized for contiguous and
 noncontiguous (strided, scatter/gather, I/O vector) data transfers.
 .
 This version contains the Fortran90 modules and the static library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/mpi-default-dev/debian_defaults

export OMPI_MCA_plm_rsh_agent=/bin/false

%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	dh_autoreconf --as-needed

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(MAKE) -k check MPIEXEC="mpiexec -np 2" ARMCI_USE_WIN_ALLOCATE=1 || cat test-suite.log
endif

## armci-mpi 0.0~git20180917

=== debian/changelog ===
armci-mpi (0.0~git20180917-2) unstable; urgency=medium

  * Team upload.
  * debian/control: mark libarmci-mpi-dev as Multi-Arch: same

 -- Drew Parsons <dparsons@debian.org>  Mon, 31 Dec 2018 13:10:35 +0100

armci-mpi (0.0~git20180917-1exp1) experimental; urgency=medium

  * Team upload.
  * update to current upstream git (dated 20180917,
    upstream commit 5678decc08ae3037179bdda8e7df60e257148a5e)
    - procedure using git remote and gbp buildpackage documented in
      debian/README.source
  * debian/control: add Vcs tags to
    https://salsa.debian.org/science-team/armci-mpi
  * Standards-Version: 4.3.0
  * debhelper compatibility level 11
    - removes explicit Build-Depends: dh-autoreconf

 -- Drew Parsons <dparsons@debian.org>  Mon, 31 Dec 2018 01:52:17 +0100

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 11),
                mpi-default-bin,
                mpi-default-dev
-Standards-Version: 3.9.6
+Standards-Version: 4.3.0
 Homepage: https://wiki.mpich.org/armci-mpi/index.php/Main_Page
+Vcs-Browser: https://salsa.debian.org/science-team/armci-mpi
+Vcs-Git: https://salsa.debian.org/science-team/armci-mpi.git
 
 Package: libarmci-mpi-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: ARMCI-MPI (Development version)

## armci-mpi 0.0~git20191105.6e593db

=== debian/changelog ===
armci-mpi (0.0~git20191105.6e593db-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * skip tests on ia64 (they consistently time out)
  * Standards-Version: 4.4.1

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Dec 2019 17:32:18 +1100

armci-mpi (0.0~git20190412.643ea1a-4) unstable; urgency=medium

  * Team upload.
  * allow oversubscribing of MPI slots when running CI tests

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Sep 2019 06:03:40 +0800

armci-mpi (0.0~git20190412.643ea1a-3) unstable; urgency=medium

  * Team upload.
  * Show contents of test-suite.log if CI tests fail.

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Sep 2019 22:40:06 +0800

armci-mpi (0.0~git20190412.643ea1a-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0
  * debhelper compatibility level 12: debhelper-compat (= 12)
  * add debian/tests (autopkgtest)

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Sep 2019 18:29:15 +0800

armci-mpi (0.0~git20190412.643ea1a-1) experimental; urgency=medium

  * Team upload.
  * Update upstream source.
  * debian/watch tracks upstream git repository at
    https://github.com/pmodels/armci-mpi
  * update debian/copyright: new upstream source url,
    tests/contrib/* licensed under BSD-2-clause.

 -- Drew Parsons <dparsons@debian.org>  Sun, 28 Apr 2019 12:46:16 +0800

=== debian/watch ===
version=4
opts="mode=git,pretty=0.0~git%cd.%h" https://github.com/pmodels/armci-mpi.git HEAD

## armci-mpi 0.3.1~beta

=== debian/changelog ===
armci-mpi (0.3.1~beta-7) unstable; urgency=medium

  * Team upload.
  * run build-time tests on only 1 process if only 1 CPU is available.
    Closes: #1031064.
  * debian/tests: don't run mpich tests on s390x. Closes: #1009772.

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Mar 2023 14:08:54 +0100

armci-mpi (0.3.1~beta-6) unstable; urgency=medium

  * Team upload.
  * fix skipping mpich build tests on ppc64, sparc64

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Mar 2022 13:07:13 +0100

armci-mpi (0.3.1~beta-5) unstable; urgency=medium

  * Team upload.
  * debian/tests Depends: gcc

 -- Drew Parsons <dparsons@debian.org>  Fri, 25 Feb 2022 01:36:51 +0100

armci-mpi (0.3.1~beta-4) unstable; urgency=medium

  * Team upload.
  * clean debian patch build_mpi_flavor.patch
  * debian/tests Depends: debhelper, dh-autoreconf
  * skip mpich build-time tests on ppc64, sparc64 (tests time out)

 -- Drew Parsons <dparsons@debian.org>  Thu, 24 Feb 2022 15:09:04 +0100

armci-mpi (0.3.1~beta-3) unstable; urgency=medium

  * Team upload.
  * print test error log from build dir

 -- Drew Parsons <dparsons@debian.org>  Thu, 24 Feb 2022 01:37:30 +0100

armci-mpi (0.3.1~beta-2) unstable; urgency=medium

  * Team upload.
  * build static libraries for both OpenMPI and MPICH
    - run debian/tests for each variant
  * make MPI-specific build using MPI_FLAVOR as library name suffix
    (set with ./configure)
    - debian patch build_mpi_flavor.patch applies MPI_FLAVOR to
      automake files
    - build in subdir for each MPI flavor
  * update debian/upstream/metadata to add Repository
    (https://github.com/pmodels/armci-mpi.git) and field
    "Other-References" instead of "Homepage"
  * Standards-Version: 4.6.0
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 Feb 2022 20:23:07 +0100

armci-mpi (0.3.1~beta-1) unstable; urgency=medium

  * New upstream prerelease.
  * debian/watch: Updated for regular Github tags/releases. 

 -- Michael Banck <mbanck@debian.org>  Sat, 07 Mar 2020 20:49:39 +0100

armci-mpi (0.3.1-beta-1exp1) experimental; urgency=medium

  * Team upload.
  * update debian/watch to watch github tag releases
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Fri, 03 Jan 2020 12:36:33 +1100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>= 11),
-               mpi-default-bin,
-               mpi-default-dev
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 13),
+ mpi-default-bin, mpi-default-dev,
+ libopenmpi-dev,
+ libmpich-dev
+Standards-Version: 4.6.0
 Homepage: https://wiki.mpich.org/armci-mpi/index.php/Main_Page
 Vcs-Browser: https://salsa.debian.org/science-team/armci-mpi
 Vcs-Git: https://salsa.debian.org/science-team/armci-mpi.git
@@ -25,4 +26,5 @@
  operations (one-sided communication) optimized for contiguous and
  noncontiguous (strided, scatter/gather, I/O vector) data transfers.
  .
- This version contains the Fortran90 modules and the static library.
+ This version contains the Fortran90 modules and the static library,
+ built against both OpenMPI and MPICH.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/mpi-default-dev/debian_defaults

export OMPI_MCA_plm_rsh_agent=/bin/false

ifeq (ia64, $(DEB_HOST_ARCH))
  DEB_BUILD_OPTIONS += nocheck
endif

empty :=
space := $(empty)$(empty)

# mpich tests time out on these arches
ARCH_SKIP_MPICH_TEST_LIST = ppc64 sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_SKIP_MPICH_TEST_LIST)$(space)))
  TEST_MPI_FLAVORS=openmpi
else
  TEST_MPI_FLAVORS=mpich openmpi
endif

%:
	dh $@ --with autoreconf

override_dh_clean:
	dh_clean
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi

override_dh_autoreconf:
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi
	tmpdir=`mktemp -d`; \
	cp -ra $(CURDIR)/* $${tmpdir}; \
	mv $$tmpdir $(CURDIR)/pristine-src
	dh_autoreconf --as-needed --sourcedirectory=$(CURDIR)/pristine-src
	cp -ra pristine-src build-mpich
	cp -ra pristine-src build-openmpi

override_dh_auto_configure:
	for mpi_flavor in mpich openmpi; do \
	  MPICC=mpicc.$${mpi_flavor} dh_auto_configure --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- MPI_FLAVOR=$${mpi_flavor}; \
	done

override_dh_auto_build:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_build --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
	done

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	set -e; \
	ncpu=`nproc`; if [ $${ncpu} -gt 1 ]; then ncpu=2; fi;\
	for mpi_flavor in $(TEST_MPI_FLAVORS); do \
	  $(MAKE) -C $(CURDIR)/build-$${mpi_flavor} -k check MPIEXEC="mpiexec.$${mpi_flavor} -np $${ncpu}" ARMCI_USE_WIN_ALLOCATE=1 || cat $(CURDIR)/build-$${mpi_flavor}/test-suite.log; \
	done
endif

override_dh_auto_install:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_install --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
	done

override_dh_link:
	dh_link -plibarmci-mpi-dev usr/lib/$(DEB_HOST_MULTIARCH)/libarmci-$(ARCH_DEFAULT_MPI_IMPL).a usr/lib/$(DEB_HOST_MULTIARCH)/libarmci.a
	dh_link -plibarmci-mpi-dev usr/lib/$(DEB_HOST_MULTIARCH)/libarmci-$(ARCH_DEFAULT_MPI_IMPL).la usr/lib/$(DEB_HOST_MULTIARCH)/libarmci.la

=== debian/tests/control ===
Tests: test-armci
Depends: @, mpi-default-bin, mpi-default-dev,
 debhelper, dh-autoreconf,
 gcc
Restrictions: allow-stderr

Tests: test-armci-openmpi
Depends: @, libopenmpi-dev,
 debhelper, dh-autoreconf,
 gcc
Restrictions: allow-stderr

Tests: test-armci-mpich
Depends: @, libmpich-dev,
 debhelper, dh-autoreconf,
 gcc
Restrictions: allow-stderr
Architecture: !s390x

## armci-mpi 0.4

=== debian/changelog ===
armci-mpi (0.4-8) unstable; urgency=medium

  * Team upload.
  * debian patch gcc-15.patch fixes build for gcc-15 (C23 standard).
    Thanks Matthias Klose for the patch (nmu 0.4-6.1).
    Closes: #1096329, #1119113.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Oct 2025 13:27:54 +0100

armci-mpi (0.4-7) unstable; urgency=medium

  * Team upload.
  * refresh build against current MPI libraries

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Oct 2025 00:08:32 +0100

armci-mpi (0.4-6) unstable; urgency=medium

  * Team upload.
  * ensure armci-mpi is rebuilt for the version of mpich (really4.2.1)
    targetted for trixie

 -- Drew Parsons <dparsons@debian.org>  Fri, 09 May 2025 00:03:34 +0200

armci-mpi (0.4-5) unstable; urgency=medium

  * Team upload.
  * debian patch openmpi5_direct_PR54.patch applies upstream PR#54
    (and PR#52) to improve operations with OpenMPI 5.
  * add lintian override for debian-rules-calls-nproc
    (use nproc to run MPI tests)
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Apr 2025 02:31:29 +0200

armci-mpi (0.4-4) unstable; urgency=medium

  * Team upload.
  * don't build or run tests for openmpi on 32-bit architectures.
    openmpi 4 is still built for these arches, but mpi-defaults
    already marks them as not supporting openmpi. Closes: #1068319

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Sep 2024 16:56:49 +0200

armci-mpi (0.4-3) unstable; urgency=medium

  * Team upload.
  * only build against openmpi or mpich where supported by the arch.
    Prepare for openmpi 5 dropping 32-bit arch support. See Bug#1068319.

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Sep 2024 19:40:56 +0200

armci-mpi (0.4-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Jul 2024 12:26:54 +0200

armci-mpi (0.4-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patches fix-test.patch and ftbfs.patch

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Jun 2024 10:13:56 +0200

armci-mpi (0.3.1-beta+git20221202.f1c4dae-1) unstable; urgency=medium

  * Team upload.
  * debian/tests: reinstate skipping mpich tests on 390x
  * apply Samuel Thibault's patch for 0.3.1~beta-7.1. Closes: #1068100.
  * debian/control: update Homepage to https://github.com/pmodels/armci-mpi

 -- Drew Parsons <dparsons@debian.org>  Sat, 06 Apr 2024 12:46:00 +0200

armci-mpi (0.3.1-beta+git20221202.f1c4dae-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream snapshot
  * debian/tests: reenable mpich tests on s390x to monitor progress
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Mar 2023 14:32:37 +0100

armci-mpi (0.3.1~beta-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * patches/fix-test.patch: Fix test_mpi_indexed_gets.c test and strengthen
    the others. Closes: #1066227.
  * patches/ftbfs.patch: Fix build with qa=+bug-implicit-func.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 30 Mar 2024 23:17:18 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: debhelper-compat (= 13),
  mpi-default-bin, mpi-default-dev,
- libopenmpi-dev,
+ libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
  libmpich-dev
-Standards-Version: 4.6.0
-Homepage: https://wiki.mpich.org/armci-mpi/index.php/Main_Page
+Standards-Version: 4.7.2
+Homepage: https://github.com/pmodels/armci-mpi
 Vcs-Browser: https://salsa.debian.org/science-team/armci-mpi
 Vcs-Git: https://salsa.debian.org/science-team/armci-mpi.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/mpi-default-dev/debian_defaults
 
 export OMPI_MCA_plm_rsh_agent=/bin/false
@@ -12,12 +13,19 @@
 empty :=
 space := $(empty)$(empty)
 
+ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(OPENMPI_AVAILABLE_ARCHITECTURES)$(space)))
+  MPI_SUPPORTED = openmpi
+endif
+ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(MPICH_AVAILABLE_ARCHITECTURES)$(space)))
+  MPI_SUPPORTED += mpich
+endif
+
 # mpich tests time out on these arches
 ARCH_SKIP_MPICH_TEST_LIST = ppc64 sparc64
 ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_SKIP_MPICH_TEST_LIST)$(space)))
   TEST_MPI_FLAVORS=openmpi
 else
-  TEST_MPI_FLAVORS=mpich openmpi
+  TEST_MPI_FLAVORS=$(MPI_SUPPORTED)
 endif
 
 %:
@@ -37,12 +45,12 @@
 	cp -ra pristine-src build-openmpi
 
 override_dh_auto_configure:
-	for mpi_flavor in mpich openmpi; do \
+	for mpi_flavor in $(MPI_SUPPORTED); do \
 	  MPICC=mpicc.$${mpi_flavor} dh_auto_configure --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- MPI_FLAVOR=$${mpi_flavor}; \
 	done
 
 override_dh_auto_build:
-	for mpi_flavor in mpich openmpi; do \
+	for mpi_flavor in $(MPI_SUPPORTED); do \
 	  dh_auto_build --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
 	done
 
@@ -56,7 +64,7 @@
 endif
 
 override_dh_auto_install:
-	for mpi_flavor in mpich openmpi; do \
+	for mpi_flavor in $(MPI_SUPPORTED); do \
 	  dh_auto_install --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
 	done

=== debian/tests/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
 Depends: @, libopenmpi-dev,
  debhelper, dh-autoreconf,
  gcc
+Architecture: !armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32
 Restrictions: allow-stderr
 
 Tests: test-armci-mpich

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/armci-mpi-$1\.tar\.gz/ \
  https://github.com/pmodels/armci-mpi/tags .*/v?(\d\S+)\.tar\.gz
